//Author: Yu Lin, LCBB, EPFL
#include <stdio.h>   
#include <math.h>
#include <stdlib.h>



//int InputSharedAd; // shared adjacencies between two genomes
//int InputGeneNumber; // number of genes
//int InputLinearChromosomeNumber1; // number of linear chromosomes of genome 1
//int InputLinearChromosomeNumber2; // number of linear chromosomes of genome 2
//int EstimatedNumber;// estimated number of random DCJ operations

int Estimator(int GeneNumber, int LinearChromosomeNumber, int SharedAd) // generate the vectors from input parameters
{
	long int k = 0; //iteration number
	double NumberAd, NumberTe, NumberDCJ; // number of adjacencies, number of telomeres, total number of possible DCJ operations
        int Tag = 1;
	double InitVector[4];// to store the initial vector
	double PreVector[4];//to store the previous vector
	double CurVector[4];//to store the current vector
	int estimator; // the estimated number
        // initialize the original vector
	InitVector[0] = GeneNumber - LinearChromosomeNumber; //S_A, number of shared adjacencies	
	PreVector[0] = InitVector[0];
	InitVector[1] = LinearChromosomeNumber * 2; // S_T, number of shared telomeres	
	PreVector[1] = InitVector[1];
	InitVector[2] = 0; //D_A, number of different adjacencies
	PreVector[2] = InitVector[2];
	InitVector[3] = 0; //D_T, number of different telomeres
	PreVector[3] = InitVector[3];
	if (InitVector[0] < SharedAd){
		Tag = 0;
		return(0);
	}
	while(Tag == 1){
		CurVector[0] = PreVector[0];
		CurVector[1] = PreVector[1];
		CurVector[2] = PreVector[2];
		CurVector[3] = PreVector[3];		
		NumberAd = PreVector[0] + PreVector[2]; //number of adjacencies
		NumberTe = PreVector[1] + PreVector[3]; //number of telomeres
		NumberDCJ = NumberAd * (NumberAd - 1) + 2 * NumberAd * NumberTe + NumberTe * (NumberTe - 1) / 2.0 + NumberAd; //total number of possible DCJ operations at this step
		CurVector[0] += ( (InitVector[0] - PreVector[0]) + PreVector[0] * (PreVector[0] - 1) * (-2.0) + PreVector[0] * (-1.0) + PreVector[0] * PreVector[1] * (-2.0) + PreVector[0] * PreVector[2] * (-2.0) + PreVector[0] * PreVector[3] * (-2.0) )/  NumberDCJ;
		CurVector[1] += ( (InitVector[1] - PreVector[1]) * (PreVector[1] + PreVector[3] + 1) + PreVector[0] * PreVector[1] * (-2.0) + PreVector[1] * (PreVector[1] - 1) * (-1.0) + PreVector[1] * PreVector[3] * (-1.0) + PreVector[1] * PreVector[2] * (-2.0) ) / NumberDCJ;
		CurVector[2] += ( PreVector[0] * (PreVector[0] - 1) * 2.0 + PreVector[0] * PreVector[1] * 2.0 + PreVector[0] * PreVector[2] * 2.0 + PreVector[0] * PreVector[3] * 2.0 + PreVector[1] * PreVector[3] * 1.0 + PreVector[1] * (PreVector[1] - 1) / 2.0 + PreVector[3] * (PreVector[3] - 1) / 2.0 - (InitVector[0] - PreVector[0]) - PreVector[2] ) / NumberDCJ;
		CurVector[3] += ( PreVector[0] * PreVector[1] * (2.0) + PreVector[1] * PreVector[2] * (2.0) + PreVector[0] * (2.0) + PreVector[2] * (2.0) + PreVector[1] * PreVector[3] * (-1.0) + PreVector[3] * (PreVector[3] - 1) * (-1.0) + (InitVector[1] - PreVector[1]) * (PreVector[1] + PreVector[3] + 1) * (-1.0) ) / NumberDCJ;	
		if ( ((CurVector[0]) < SharedAd) && ((PreVector[0]) >= SharedAd)){
			Tag = 0;
			if ((SharedAd - CurVector[0]) > (PreVector[0] - SharedAd))
				estimator = k;
			else
				estimator = k + 1;
			}
		if (CurVector[0] < 0.5){
			Tag = 0;
			estimator = k + 1;
			}	
		k++;
		PreVector[0] = CurVector[0];
		PreVector[1] = CurVector[1];
		PreVector[2] = CurVector[2];
		PreVector[3] = CurVector[3];
		}
		return(estimator);
}

int GetEstimate(int InputGeneNumber, int InputLinearChromosomeNumber1, int InputLinearChromosomeNumber2, int InputSharedAd) // output the estimated number
{
        if (InputLinearChromosomeNumber1 > InputLinearChromosomeNumber2)
           return Estimator(InputGeneNumber,InputLinearChromosomeNumber1,InputSharedAd);
        else
           return Estimator(InputGeneNumber,InputLinearChromosomeNumber2,InputSharedAd);
	//int EstimatedNumber = (Estimator(InputGeneNumber,InputLinearChromosomeNumber1,InputSharedAd) + Estimator			(InputGeneNumber,InputLinearChromosomeNumber2,InputSharedAd)) / 2;
	//if (InputSharedAd > 0.01 * (InputGeneNumber - InputLinearChromosomeNumber1) )
		//printf("Estimated Number of Random DCJ Operations between Two Genomes is %d.\n", EstimatedNumber);
	//else 
		//printf("\nThere are less than one percent common adjacencies left!\nEstimated Number of Random DCJ Operations between Two Genomes is %d.\n", EstimatedNumber);
        //return EstimatedNumber;
}


