//Author: Yu Lin, LCBB, EPFL 

#include <stdio.h>
#include <malloc.h>
#include <memory.h>
#include <stdlib.h>
#include <string.h>
#include <list>
#include <limits.h>
#include <math.h>
#include <assert.h>


#include <stdlib.h>
#include <iostream>

using namespace std;


struct Ptree
{
	int leaf_number;
	int edge_number;
	int *parent;
	int *lchild;
	int *rchild;
	int **edge; //vector representation for bipatitions
	double *branchlength; // store the length of the branch attached to the child node
	double *support;
};  

struct BinList
{
	int *code;
	int leaf_number;
	int count;
	int index;
	int tag2; //whether it is in the inferred tree
	double l2; // the branch length in inferred tree
	struct BinList *Pnext;
	int parent;
	int child;
};

struct BinList BCoding[1129];

//struct Ptree tree1, tree2;

void pttree(struct Ptree *treeA, int node){
	int i;
 	//getchar();
	//int total = treeA.leaf_number*2-1;
	//printf("Node:%d, leaveNUM: %d \n", node, (*treeA).leaf_number);
	if (((*treeA).lchild[node] == -1) &&  ((*treeA).rchild[node] == -1)){
		if (node != 0){
			for(i=0; i<(*treeA).leaf_number; i++){	
				(*treeA).edge[node][i] = 0;
			}
			(*treeA).edge[node][node] = 1;
		}else{
			for(i=0; i<(*treeA).leaf_number; i++){	
				(*treeA).edge[node][i] = 1;
			}
			(*treeA).edge[node][node] = 0;
		}
	//printf("LEAVE Node:%d\n", node);
	}else{
		//printf("Node:%d -> (%d,%d)\n", node,(*treeA).lchild[node],(*treeA).rchild[node]);
		if ((*treeA).lchild[node] != -1)
			pttree(treeA, (*treeA).lchild[node]);
		if ((*treeA).rchild[node] != -1)
			pttree(treeA, (*treeA).rchild[node]);
		for(i=0; i<(*treeA).leaf_number; i++){	
			(*treeA).edge[node][i] = ( (*treeA).edge[(*treeA).lchild[node]][i] + (*treeA).edge[(*treeA).rchild[node]][i] ) % 2;
		}
	//printf("INTER Node:%d\n", node);
	}
}


void newick2lcbb(FILE *fp, int num_leaves, struct Ptree *tree)
{
	char *tree_str;
	tree_str= (char *)malloc(sizeof(char) * (10000));
	//char tree_str[20000];
	int root;
	char *temp1, *temp2, *temp3;
	temp1= (char *)malloc(sizeof(char) * (100));
	temp2= (char *)malloc(sizeof(char) * (100));
	temp3= (char *)malloc(sizeof(char) * (100));
	//char temp1[100],temp2[100],temp3[100];
	fscanf(fp,"%s", temp1);
//printf("%s\n", temp1);
	fscanf(fp,"%s", temp2);
//printf("%s\n", temp2);
	fscanf(fp,"%s", temp3);
//printf("%s\n", temp3);
	fscanf(fp,"%s\n", tree_str);
	//printf("%s******\n\n", tree_str); getchar();
	//fgets(tree_str, MAXTREESTRLEN, fp);	
	//fclose(fp);

//printf("%d %s\n", strlen(tree_str), tree_str); getchar();

	list<int> l;
	list<double> ll;
	char temp[50000];
	int state = 0;
	int index;
	int int_node = num_leaves + 2;
	int node1, node2;
	double edgelen;
	int i,j,k;

	root = num_leaves+1;
	(*tree).leaf_number = num_leaves;
	for(i=0; i<num_leaves*2; i++){	
		(*tree).parent[i] = -1;
		(*tree).lchild[i] = -1;
		(*tree).rchild[i] = -1;
		for(j=0; j<num_leaves; j++){
			(*tree).edge[i][j] = 0;
		}
	}

	for(i = 0; i < strlen(tree_str); i++){
		if (tree_str[i] == ')'){
			if (state == 3){
				k = 0;
				for(j = index; j < i; j++, k++)	
					temp[k] = tree_str[j];
				temp[k] = 0;
				ll.push_front(atof(temp));
				//printf(") pushing %lf\n", atof(temp));
				//getchar();
				state = 3;
			}
			node1 = l.front();
			l.pop_front();
			edgelen = ll.front(); 
			ll.pop_front();
			//edge
			//printf("%d %d %lf\n", int_node, node1, edgelen);
			(*tree).branchlength[node1-1] = edgelen;
			(*tree).parent[node1-1] = int_node-1;
			if ((*tree).lchild[int_node-1] == -1){
				//tree2.lchild[parent-1] = child-1;
				(*tree).lchild[int_node-1] = node1-1;
			}else{ 
				//tree2.rchild[parent-1] = child-1;
				(*tree).rchild[int_node-1] = node1-1;
			}

			node1 = l.front();
			l.pop_front();
			edgelen = ll.front();
			ll.pop_front();
			//edge
			//printf("%d %d %lf\n", int_node, node1, edgelen);
			(*tree).branchlength[node1-1] = edgelen;
			(*tree).parent[node1-1] = int_node-1;
			if ((*tree).lchild[int_node-1] == -1){
				//tree2.lchild[parent-1] = child-1;
				(*tree).lchild[int_node-1] = node1-1;
			}else{ 
				//tree2.rchild[parent-1] = child-1;
				(*tree).rchild[int_node-1] = node1-1;
			}
			l.push_front(int_node);
			//printf(") pushing %d\n", int_node);
			//getchar();
			int_node += 1;	
		}
		else if (tree_str[i] == ':'){
			if (state == 1){	
				k = 0;	
				for(j = index; j < i; j++, k++)
                                        temp[k] = tree_str[j];
                                temp[k] = 0;
				l.push_front(atoi(temp));
				//printf(": pushing %d\n", atoi(temp)+1);
				//getchar();
			}
			state = 2;
		}
		else if (tree_str[i] == ','){
			if (state == 3){
				k = 0;
				for(j = index; j < i; j++, k++)
                                        temp[k] = tree_str[j];
                                temp[k] = 0;
				ll.push_front(atof(temp));
				//printf(", pushing %lf\n", atof(temp));
				//getchar();
				state = 0;
			}	
		}
		else if (tree_str[i] != '('){
			if (state == 0){
				index = i;
				state = 1;
			}
			else if (state == 2){
				index = i;
				state = 3;
			}
		}
	}
	if (l.size() == 2){
		node1 = l.front();
		l.pop_front();
		node2 = l.front();
		l.pop_front();
		edgelen = ll.front();
		ll.pop_front();
   		assert(ll.size() == 0);
		//fake root edges
		printf("%f\n", edgelen);
		//printf("%d %d\n", num_leaves+1, node2);
		(*tree).branchlength[node1-1] = edgelen;
		(*tree).parent[node1-1] = num_leaves;
		if ((*tree).lchild[num_leaves] == -1){
			(*tree).lchild[num_leaves] = node1-1;
		}else{ 
			(*tree).rchild[int_node-1] = node1-1;
		}
		(*tree).parent[node2-1] = num_leaves;
		(*tree).branchlength[node2-1] = 0;
		if ((*tree).lchild[num_leaves] == -1){
			(*tree).lchild[num_leaves] = node2-1;
		}else{ 
			(*tree).rchild[num_leaves] = node2-1;
		}
	}
	else{
		printf("input format incorrect! compare with sample tree of 8 leaves: (((6:0.08,4:0.07):0.16,1:0.27):0.18,(5:0.04,((3:0.00,2:0.00):0.04,7:0.05):0.00):0.01,0:0.08);\n");getchar();
	}
//printf("input correct!\n"); getchar();

	free(tree_str);
	free(temp1);
	free(temp2);
	free(temp3);
//printf("free correct!\n"); getchar();
	pttree(tree,num_leaves);
//printf("pt correct!\n"); getchar();


}


int vecdistance(struct Ptree *treeA, int a, struct Ptree *treeB, int b){
	int i;	
	for(i=0; i<(*treeA).leaf_number; i++){	
		if ( (*treeA).edge[a][i] != (*treeB).edge[b][i] )
			return(0);
	}
	return(1);
}

int comp_vec(int *a, int *b, int num){
//printf("Comparing!!\n");
	int i;	
	for(i=0; i<num; i++){	
		if ( a[i] != b[i] )
			return(0);
	}
	return(1);
}


double first_vec(struct Ptree *treeB, int b){
	int i, j, tag;
	int temp = 0;
	int index = 0;
	struct BinList *Pointer, *PP;
	for(i=0; i<(*treeB).leaf_number; i++){	
		if (i% 10 == 0){
			temp = temp * 2 + (*treeB).edge[b][i] ;
			index = (index + temp) % 1129;
			temp = 0;
		}else{
			temp = temp * 2 + (*treeB).edge[b][i] ;
		}
	}
	index = (index + temp) % 1129;
	tag = 1;
	Pointer = &BCoding[index];
	while(tag){
		if ((BCoding[index].tag2 == 0)){
			//printf("OK!");
			//getchar();
			BCoding[index].tag2 = 1;
			BCoding[index].code = (int *)malloc(sizeof(int) * ((*treeB).leaf_number));
			for(j=0; j<(*treeB).leaf_number; j++){
				BCoding[index].code[j] = (*treeB).edge[b][j];
			}
			BCoding[index].leaf_number = (*treeB).leaf_number;
			tag = 0;
			BCoding[index].count = 0;
			BCoding[index].l2 = (*treeB).branchlength[b];
			BCoding[index].parent = (*treeB).parent[b];
			BCoding[index].child = b;
		}else{
			while((Pointer != NULL)&&tag){
				if (comp_vec((*Pointer).code, (*treeB).edge[b],(*treeB).leaf_number)){
					if ((*Pointer).tag2 > 0)
						printf("Error! No same two bi-Partitions in first tree.\n");
					else{
						(*Pointer).tag2 = 1;
						(*Pointer).l2 = (*treeB).branchlength[b];
					}
					tag = 0;
				}else{
					PP = Pointer;
					Pointer = (*Pointer).Pnext;	
				}
			}
			if (tag){
				struct BinList *newnode = (BinList *)malloc(sizeof (struct BinList));
				(*PP).Pnext = newnode;
				(*newnode).tag2 = 1;
				(*newnode).count = 0;
				(*newnode).code = (int *)malloc(sizeof(int) * ((*treeB).leaf_number));
				for(j=0; j<(*treeB).leaf_number; j++){
					(*newnode).code[j] = (*treeB).edge[b][j];				
				}
				(*newnode).Pnext = NULL;
				(*newnode).leaf_number = (*PP).leaf_number;
				(*newnode).l2 = (*treeB).branchlength[b];
				(*newnode).parent = (*treeB).parent[b];
				(*newnode).child = b;
				tag = 0;
			}
		}
	}
}



double add_vec(struct Ptree *treeB, int b){
	int i, j, tag;
	int temp = 0;
	int index = 0;
	struct BinList *Pointer, *PP;
	for(i=0; i<(*treeB).leaf_number; i++){	
		if (i% 10 == 0){
			temp = temp * 2 + (*treeB).edge[b][i] ;
			index = (index + temp) % 1129;
			temp = 0;
		}else{
			temp = temp * 2 + (*treeB).edge[b][i] ;
		}
	}
	index = (index + temp) % 1129;
	tag = 1;
	Pointer = &BCoding[index];
	while(tag){
		if ((BCoding[index].count == 0)&&(BCoding[index].tag2 == 0)){
//printf("ERROR at %d, Tree B :%d\n", index, b);
			/*BCoding[index].index = index;
			for(j=0; j<(*treeB).leaf_number; j++){
				BCoding[index].code[j] = (*treeB).edge[b][j];
			}
			BCoding[index].leaf_number = (*treeB).leaf_number;
			BCoding[index].count = BCoding[index].count + 1;
			BCoding[index].parent = -1;
			BCoding[index].child = -1;
			tag = 0;*/
			tag = 0;
		}else{
			while((Pointer != NULL)&&tag){
				if (comp_vec((*Pointer).code, (*treeB).edge[b],(*treeB).leaf_number)){
					(*Pointer).count = (*Pointer).count + 1;					
					tag = 0;
					//printf("XXX!\n");
					//getchar();
				}else{
					PP = Pointer;
					Pointer = (*Pointer).Pnext;
				}
			}
			/*if (tag){
//printf("ERROR at %d, Tree B :%d\n", index, b);
				struct BinList *newnode = malloc(sizeof (struct BinList));
				(*PP).Pnext = newnode;
				for(j=0; j<(*treeB).leaf_number; j++){
					(*newnode).code[j] = (*treeB).edge[b][j];				}
				(*newnode).Pnext = NULL;
				(*newnode).leaf_number = (*PP).leaf_number;
				(*newnode).count =  1;
				(*newnode).tag2 =  0;
				(*newnode).parent = -1;
				(*newnode).child = -1;
				tag = 0;
			}*/
			tag = 0;
			
		}

	}
}

int write_tree_nj1(struct Ptree *treeA, int node, char* node_rep, char ** names){
	int i;
	char temp1[100000];
	char temp2[100000];
	int pointer,pre;
	//int tag[10000];

	if (((*treeA).lchild[node] == -1) &&  ((*treeA).rchild[node] == -1) && ((*treeA).parent[node]!= ((*treeA).leaf_number*2 - 2) ) ){
		sprintf(node_rep,"%s:%.2f",names[node],(*treeA).branchlength[node]);
	}else if (((*treeA).lchild[node] == -1) &&  ((*treeA).rchild[node] == -1) && ((*treeA).parent[node]== ((*treeA).leaf_number*2 - 2) ) ){
                sprintf(node_rep,"%s:%.2f",names[node],(*treeA).branchlength[(*treeA).lchild[(*treeA).leaf_number*2 - 2]]+(*treeA).branchlength[(*treeA).rchild[(*treeA).leaf_number*2 - 2]] );
	}else{
		//printf("Node:%d -> (%d,%d)\n", node,(*treeA).lchild[node],(*treeA).rchild[node]);
		if ((*treeA).lchild[node] != -1)
			write_tree_nj1(treeA, (*treeA).lchild[node], temp1, names);
		if ((*treeA).rchild[node] != -1)
			write_tree_nj1(treeA, (*treeA).rchild[node], temp2, names);
		if ((*treeA).parent[node]!= ((*treeA).leaf_number*2 - 2) ) 
			sprintf(node_rep,"(%s,%s):%.2f",temp1,temp2,(*treeA).branchlength[node]);	
		else
			sprintf(node_rep,"(%s,%s):%.2f",temp1,temp2,(*treeA).branchlength[(*treeA).lchild[(*treeA).leaf_number*2 - 2]]+(*treeA).branchlength[(*treeA).rchild[(*treeA).leaf_number*2 - 2]]);
	}
}


int write_tree_nj2(struct Ptree *treeA, int node, char* node_rep, char ** names){
	int i;
	char temp1[100000];
	char temp2[100000];
	int pointer,pre;
	//int tag[10000];

	if (((*treeA).lchild[node] == -1) &&  ((*treeA).rchild[node] == -1)){
		sprintf(node_rep,"%s:%.2lf",names[node],(*treeA).support[node]);
	}else{
		//printf("Node:%d -> (%d,%d)\n", node,(*treeA).lchild[node],(*treeA).rchild[node]);
		if ((*treeA).lchild[node] != -1)
			write_tree_nj2(treeA, (*treeA).lchild[node], temp1, names);
		if ((*treeA).rchild[node] != -1)
			write_tree_nj2(treeA, (*treeA).rchild[node], temp2, names);
		sprintf(node_rep,"(%s,%s):%.2f",temp1,temp2,(*treeA).support[node]);	
	}
}


int write_tree_fme1(struct Ptree *treeA, int node, char* node_rep, char ** names){
	int i;
	char temp1[100000];
	char temp2[100000];
	int pointer,pre;
	//int tag[10000];

	if (((*treeA).lchild[node] == -1) &&  ((*treeA).rchild[node] == -1) && ((*treeA).parent[node]!= ((*treeA).leaf_number) ) ){
		sprintf(node_rep,"%s:%.2f",names[node],(*treeA).branchlength[node]);
	}else if (((*treeA).lchild[node] == -1) &&  ((*treeA).rchild[node] == -1) && ((*treeA).parent[node]== (*treeA).leaf_number ) ){
                sprintf(node_rep,"%s:%.2f",names[node],(*treeA).branchlength[(*treeA).lchild[(*treeA).leaf_number]]+(*treeA).branchlength[(*treeA).rchild[(*treeA).leaf_number]] );
	}else{
		//printf("Node:%d -> (%d,%d)\n", node,(*treeA).lchild[node],(*treeA).rchild[node]);
		if ((*treeA).lchild[node] != -1)
			write_tree_fme1(treeA, (*treeA).lchild[node], temp1, names);
		if ((*treeA).rchild[node] != -1)
			write_tree_fme1(treeA, (*treeA).rchild[node], temp2, names);
		if ((*treeA).parent[node]!= (*treeA).leaf_number) 
			sprintf(node_rep,"(%s,%s):%.2f",temp1,temp2,(*treeA).branchlength[node]);	
		else
			sprintf(node_rep,"(%s,%s):%.2f",temp1,temp2,(*treeA).branchlength[(*treeA).lchild[(*treeA).leaf_number]]+(*treeA).branchlength[(*treeA).rchild[(*treeA).leaf_number]]);
	}
}


int write_tree_fme2(struct Ptree *treeA, int node, char* node_rep, char ** names){
	int i;
	char temp1[100000];
	char temp2[100000];
	int pointer,pre;
	//int tag[10000];
	if (((*treeA).lchild[node] == -1) &&  ((*treeA).rchild[node] == -1)){
		sprintf(node_rep,"%s:%.2lf",names[node],(*treeA).support[node]);
	}else{
		//printf("Node:%d -> (%d,%d)\n", node,(*treeA).lchild[node],(*treeA).rchild[node]);
		if ((*treeA).lchild[node] != -1)
			write_tree_fme2(treeA, (*treeA).lchild[node], temp1, names);
		if ((*treeA).rchild[node] != -1)
			write_tree_fme2(treeA, (*treeA).rchild[node], temp2, names);
		sprintf(node_rep,"(%s,%s):%.2f",temp1,temp2,(*treeA).support[node]);	
	}
}



void Newick_NJ(int leaf_number, char *filename1, char *filename2, struct Ptree *treeA, char ** names)
{
        FILE *fq,*fp;
	int temp;
        fp = fopen(filename2, "w");
	fq = fopen(filename1, "w");

	//printf("files opened\n");
        int i,j;                      //index i and j
	int root1, root2; // root of tree1 and tree2
	int triv1, triv2; // 
	int parent, child;
	double dtemp;
	int tree2degree[12000];
	char tmp1[40000],tmp2[40000],tmp3[40000];
	char final_tree[150000];

        
	root2 = 2*leaf_number-2;
	if ((*treeA).lchild[root2] > leaf_number-1){
		triv2 = (*treeA).lchild[root2];
		triv1 = (*treeA).rchild[root2];
	}
	else if ((*treeA).rchild[root2] > leaf_number-1){
		triv2 = (*treeA).rchild[root2];
		triv1 = (*treeA).lchild[root2];
	}

	write_tree_nj1(treeA,triv1,tmp1,names);
	write_tree_nj1(treeA,(*treeA).lchild[triv2],tmp2,names);
	write_tree_nj1(treeA,(*treeA).rchild[triv2],tmp3,names);
	sprintf(final_tree,"(%s,%s,%s)",tmp1,tmp2,tmp3);
	fprintf(fq,"%s;", final_tree);
	//printf("%s;", final_tree);
	fclose(fq);

	write_tree_nj2(treeA,triv1,tmp1,names);
	write_tree_nj2(treeA,(*treeA).lchild[triv2],tmp2,names);
	write_tree_nj2(treeA,(*treeA).rchild[triv2],tmp3,names);
	sprintf(final_tree,"(%s,%s,%s)",tmp1,tmp2,tmp3);
	fprintf(fp,"%s;", final_tree);
	//printf("%s;", final_tree);
	fclose(fp);

}

void Newick_FME(int leaf_number, char *filename1, char *filename2, struct Ptree *treeA, char ** names)
{
        FILE *fq,*fp;
	int temp;
        fp = fopen(filename2, "w");
	fq = fopen(filename1, "w");

	//printf("files opened\n");
        int i,j;                      //index i and j
	int root1, root2; // root of tree1 and tree2
	int triv1, triv2; // 
	int parent, child;
	double dtemp;
	int tree2degree[12000];
	char tmp1[40000],tmp2[40000],tmp3[40000];
	char final_tree[150000];

        
	root2 = leaf_number;
	if ((*treeA).lchild[root2] > leaf_number-1){
		triv2 = (*treeA).lchild[root2];
		triv1 = (*treeA).rchild[root2];
	}
	else if ((*treeA).rchild[root2] > leaf_number-1){
		triv2 = (*treeA).rchild[root2];
		triv1 = (*treeA).lchild[root2];
	}

	write_tree_fme1(treeA,triv1,tmp1,names);
	write_tree_fme1(treeA,(*treeA).lchild[triv2],tmp2,names);
	write_tree_fme1(treeA,(*treeA).rchild[triv2],tmp3,names);
	sprintf(final_tree,"(%s,%s,%s)",tmp1,tmp2,tmp3);
	fprintf(fq,"%s;", final_tree);
	//printf("%s;", final_tree);
	fclose(fq);

	write_tree_fme2(treeA,triv1,tmp1,names);
	write_tree_fme2(treeA,(*treeA).lchild[triv2],tmp2,names);
	write_tree_fme2(treeA,(*treeA).rchild[triv2],tmp3,names);
	sprintf(final_tree,"(%s,%s,%s)",tmp1,tmp2,tmp3);
	fprintf(fp,"%s;", final_tree);
	//printf("%s;", final_tree);
	fclose(fp);

}


void show_fme(int numbs, struct Ptree *treeA){
	//FILE *fp;
	char filename[100];
	//fp = fopen(sub, "a");     //write into a file , write only
	int i;
	double sum=0.0;
	int dis=0;
	struct BinList *Pointer, *PP;
	for(i=0; i<1129; i++){
		if ( (BCoding[i].count > 0) || (BCoding[i].tag2 > 0) ){	
				if (BCoding[i].tag2 == 1){				
					//fprintf(fp,"(%d,%d): %.2lf\n", BCoding[i].parent+1,BCoding[i].child+1, (double)BCoding[i].count/(double)numbs);
					(*treeA).support[BCoding[i].child] = (double)BCoding[i].count/(double)numbs;
				}
			}
			Pointer = BCoding[i].Pnext;
			//dis++;
			while(Pointer != NULL){
				if ((*Pointer).tag2 == 1){
					//fprintf(fp,"(%d,%d): %.2lf\n", (*Pointer).parent+1,(*Pointer).child+1, (double)(*Pointer).count/(double)numbs);
					//printf("show tag: %d\n",(*Pointer).tag);
					(*treeA).support[(*Pointer).child] = (double)(*Pointer).count/(double)numbs;
					if ((*treeA).parent[(*Pointer).child] ==  (*treeA).leaf_number){
						(*treeA).support[(*treeA).lchild[(*treeA).leaf_number]] = (double)(*Pointer).count/(double)numbs;
						(*treeA).support[(*treeA).rchild[(*treeA).leaf_number]] = (double)(*Pointer).count/(double)numbs;
					}
				}
				Pointer = (*Pointer).Pnext;
				//dis++;
			}		
	}
	//for(i=0; i<triv; i++){
	//	fprintf(fp,"%d	%d	%d\n", 1,1, mn - 1);
	//}

        //fclose(fp);

	for(i=0; i<1129; i++){
		Pointer = BCoding[i].Pnext;
		if (BCoding[i].tag2 == 1)
			free(BCoding[i].code);
		while(Pointer != NULL){
			PP = Pointer;
			if ((*Pointer).tag2 == 1)
				free((*Pointer).code);			
			Pointer = (*Pointer).Pnext;
			free(PP);
		}		
	}
}

void show_nj(int numbs, struct Ptree *treeA){
	//FILE *fp;
	char filename[100];
	//fp = fopen(sub, "a");     //write into a file , write only
	int i;
	double sum=0.0;
	int dis=0;
	struct BinList *Pointer, *PP;
	for(i=0; i<1129; i++){
		if ( (BCoding[i].count > 0) || (BCoding[i].tag2 > 0) ){	
				if (BCoding[i].tag2 == 1){				
					//fprintf(fp,"(%d,%d): %.2lf\n", BCoding[i].parent+1,BCoding[i].child+1, (double)BCoding[i].count/(double)numbs);
					(*treeA).support[BCoding[i].child] = (double)BCoding[i].count/(double)numbs;
				}
			}
			Pointer = BCoding[i].Pnext;
			//dis++;
			while(Pointer != NULL){
				if ((*Pointer).tag2 == 1){
					//fprintf(fp,"(%d,%d): %.2lf\n", (*Pointer).parent+1,(*Pointer).child+1, (double)(*Pointer).count/(double)numbs);
					//printf("show tag: %d\n",(*Pointer).tag);
					(*treeA).support[(*Pointer).child] = (double)(*Pointer).count/(double)numbs;
					if ((*treeA).parent[(*Pointer).child] ==  (2*(*treeA).leaf_number-2) ){
						(*treeA).support[(*treeA).lchild[2*(*treeA).leaf_number-2]] = (double)(*Pointer).count/(double)numbs;
						(*treeA).support[(*treeA).rchild[2*(*treeA).leaf_number-2]] = (double)(*Pointer).count/(double)numbs;
					}
				}
				Pointer = (*Pointer).Pnext;
				//dis++;
			}		
	}
	//for(i=0; i<triv; i++){
	//	fprintf(fp,"%d	%d	%d\n", 1,1, mn - 1);
	//}

        //fclose(fp);

	for(i=0; i<1129; i++){
		Pointer = BCoding[i].Pnext;
		if (BCoding[i].tag2 == 1)
			free(BCoding[i].code);
		while(Pointer != NULL){
			PP = Pointer;
			if ((*Pointer).tag2 == 1)
				free((*Pointer).code);			
			Pointer = (*Pointer).Pnext;
			free(PP);
		}		
	}
}

void NJtree(int genome_num, struct Ptree *treeA, double ** DIS, int num_bs, int num_leaves, int num_genes){
        int cluster_num = genome_num;
        double dis_min;
        int i_min, j_min;
        int i,j;
        int* cluster_sign = (int *)malloc(genome_num * sizeof (int)); // sign of clustering
        int* parent = (int *)malloc(genome_num * 2 * sizeof (int)); // parent pointer
        double* row_distance = (double *)malloc(genome_num * sizeof (double)); // store the sum of row values
        double ** distance = (double **)malloc(sizeof(double *) * (num_leaves));
        for(i=0; i<num_leaves; i++){
                distance[i] = (double *)malloc(sizeof(double) * (num_leaves));
        } // store the whole matrix for all the pairwise distance
        double temp_distance, branch1, branch2; // store the temp pairwise distance
        int new_internal = genome_num; // the index of the new internal node
        for(i=0; i<cluster_num; i++){
                //distance[i] = malloc(genome_num * sizeof (double));
                cluster_sign[i] = 100+i; // each genome is a single cluster
                parent[2*i] = -1; // init
                parent[2*i+1] = -1; //init
        }

        (*treeA).leaf_number = genome_num;
        (*treeA).edge_number = genome_num-1;
        for(i=0; i<genome_num * 2; i++){
                (*treeA).parent[i] = -1;
                (*treeA).lchild[i] = -1;
                (*treeA).rchild[i] = -1;
                (*treeA).branchlength[i] = -1001;
                for(j=0; j<genome_num; j++){
                        (*treeA).edge[i][j] = 0;
                }
                //(*treeA).edge[i][i] = 1;
        }

        // copy the distance matrix DIS to distance
        for(i=0; i<cluster_num; i++)
                for(j=0; j<cluster_num; j++){
                        distance[i][j] = distance[j][i] = DIS[i][j];
                }

//printf("complete!!!\n");getchar();

        while (cluster_num > 1) { //there are still more than 2 clusters

                for(i=0; i<genome_num; i++){ // compute the sum of row distances
                        distance[i][i]= 0;
                        row_distance[i] = 0;
                        for(j=0; j<genome_num; j++){
                                if ((j != i) && (cluster_sign[i] > 0) && (cluster_sign[j] > 0))
                                        row_distance[i] += distance[i][j];
                        }
                }

                dis_min = INT_MAX;
                for(i=0; i<genome_num; i++){ // get the new pairwise distnce and find the closest pair
                        for(j=0; j<genome_num; j++){
				if ((j != i) && (cluster_sign[i] > 0) && (cluster_sign[j] > 0)){
                                        if (cluster_num > 2){
                                                temp_distance = distance[i][j] - (row_distance[i] + row_distance[j])/(cluster_num-2);
                                                if (dis_min > temp_distance){
                                                        dis_min = temp_distance;
                                                        i_min = i;
                                                        j_min = j;
                                                }
                                        }else{
                                                        i_min = i;
                                                        j_min = j;
                                        }

                                }
                        }
                }

                for(j=0; j<genome_num; j++){
                        if ((j != i_min)&& (j != j_min) && (cluster_sign[j] > 0)) {
                                temp_distance = (distance[i_min][j] + distance[j_min][j] - distance[i_min][j_min])/2;
                                distance[i_min][j] = distance[j][i_min] = temp_distance;
        //printf(" %d to (%d,%d): %f\n",j, i_min,j_min,distance[i_min][j]);
        //getchar();
                        }
                }

                if ((cluster_num-2) > 0){
                        branch1 = distance[i_min][j_min]/2 + (row_distance[i_min] - row_distance[j_min])/((cluster_num-2)*2);
                        branch2 = distance[i_min][j_min]/2 + (row_distance[j_min] - row_distance[i_min])/((cluster_num-2)*2);
                }else{
                        branch1 = distance[i_min][j_min];
                        branch2 = 0;
                }
                cluster_num = cluster_num - 1;
        //printf("i_min,j_min: %d,%d (cluster_sign %d, %d)\n",i_min+1,j_min+1,cluster_sign[i_min],cluster_sign[j_min]);
                cluster_sign[j_min] = -100; // delete j_min
        //printf("i_min,j_min: %d,%d (cluster_sign %d, %d)\n",i_min+1,j_min+1,cluster_sign[i_min],cluster_sign[j_min]);
                while (parent[i_min] != -1){
                        i_min = parent[i_min];
                }
                while (parent[j_min] != -1){
                        j_min = parent[j_min];
                }

        //printf("i_min,j_min: %d,%d -> %d (cluster_sign %d, %d)\n",i_min+1,j_min+1, new_internal+1,cluster_sign[i_min],cluster_sign[j_min]);
        //getchar();
               	parent[i_min]= new_internal;
               	parent[j_min]= new_internal;

                if (((*treeA).branchlength[i_min] == -1001)&&((*treeA).branchlength[j_min] == -1001)){
                        if ((cluster_num-1) > 0){
                                (*treeA).branchlength[i_min] = branch1;
                                (*treeA).branchlength[j_min] = branch2;
                        }else{
                                if (i_min < j_min){
                                        (*treeA).branchlength[i_min] = branch1;
                                        (*treeA).branchlength[j_min] = branch2;
                                }else{
                                        (*treeA).branchlength[i_min] = branch2;
                                        (*treeA).branchlength[j_min] = branch1;
                                }
                        }
                }else{
                        printf("ERROR in NJ-tree reconstruction!");
                }

                (*treeA).parent[i_min] = new_internal;
                (*treeA).parent[j_min] = new_internal;
                (*treeA).lchild[new_internal] = i_min;
                (*treeA).rchild[new_internal] = j_min;
                new_internal++;
        }

//printf("%d\n", (*treeA).leaf_number*2-2);getchar();
        pttree(treeA, 2*(*treeA).leaf_number-2);
        /*for(i=(*treeA).leaf_number; i<(*treeA).leaf_number * 2-3; i++){
                printf ("Edge %d: (",i);        
                for(j = 0; j < (*treeA).leaf_number; j++){
                        printf ("%d ",(*treeA).edge[i][j]);
                }
                printf (")\n"); 
        }*/

        free(cluster_sign);
        free(parent);
        free(row_distance);
        for(i = 0; i < num_leaves; i++)
                free(distance[i]);
        free(distance);

}




void generate_fme_matrix(char *matrixfile, char* fastme_file, int num_bs, int num_leaves, int num_genes){
        FILE *fp;
        FILE *fq;
        FILE *fdiff;
        int temp;
        int i,j,iii;               //index i and j
        int root;
        int parent, child;
        double dtemp;
        int testsnum;
        int branchmax, dismax;
        double berror;
        int filenumber = 1;
        char filename[100];
        char somenumber[100];
        int matrixnum, mn;

        double **DIS = (double **)malloc(sizeof(double *) * (num_leaves));
        for(i=0; i<num_leaves; i++){
                DIS[i] = (double *)malloc(sizeof(double) * (num_leaves));
        }


        for(iii=0; iii<filenumber; iii=iii+1){
                fp = fopen(matrixfile, "r");
                if (fp == NULL)
                        printf("Error in file opening!\n");
                fq = fopen(fastme_file, "w");
                if (fq == NULL)
                        printf("Error in file opening!\n");
                matrixnum = mn = 1 + num_bs;
                while(matrixnum > 0){
                        fscanf(fp, "%d ", &temp);
                        fprintf(fq, "%d\n", temp);
                        //if (temp != root-1)
                                //printf("leaf number error!\n");
                        for(i=0; i<temp; i++){
                                for(j=i+1; j<temp; j++){
                                        fscanf(fp, "%d %d %lf", &parent, &child, &dtemp);
                                        DIS[i][j] = dtemp;
                                        if ( (parent != i+1) && (child != j+1) ){
                                                printf("ERROR in indexing! (%d,%d) vs (%d,%d)", parent, child, i+1,j+1);
                                                getchar();
                                        }
                                        DIS[j][i] = DIS[i][j];
                                }
                                DIS[i][i] = 0;
                        }

                        for(i=0; i<temp; i++){
                                fprintf(fq, "%d\n", i+1);
                                for(j=0; j<temp; j++){
                                        fprintf(fq, "%lf\n", DIS[i][j]);
                                }
                        }
                        matrixnum--;
                }
                fclose(fp);
                fclose(fq);
        }
	for(i = 0; i < num_leaves; i++)
                free(DIS[i]);
        free(DIS);


}




//main(int argc, char *argv[]){
void write_fme_tree(char *fastmetreefile, char* resultfile1, char* resultfile2, int num_bs, int num_leaves, int num_genes, char ** names){ 
        FILE *fp;
	FILE *fq;
	FILE *fdiff;
	int temp;
        int i,j,iii;               //index i and j
	int root;
	int parent, child;
	double dtemp;
	int testsnum;
	int branchmax, dismax;
	double berror;
	int filenumber = 1;
	char filename[100];
	char somenumber[100];
	int matrixnum, mn;
	struct Ptree tree1;
	struct Ptree tree2;
	struct Ptree tree3;

	tree1.leaf_number = num_leaves;
	tree1.parent = (int *)malloc(sizeof(int) * (2*num_leaves));
	tree1.lchild = (int *)malloc(sizeof(int) * (2*num_leaves));
	tree1.rchild = (int *)malloc(sizeof(int) * (2*num_leaves));
	tree1.branchlength = (double *)malloc(sizeof(double) * (2*num_leaves));
	tree1.support = (double *)malloc(sizeof(double) * (2*num_leaves));
	tree1.edge = (int **)malloc(sizeof(int *) * (2*num_leaves));
	for(i=0; i<2*num_leaves; i++){
		tree1.edge[i] = (int *)malloc(sizeof(int) * (num_leaves));
	}

	tree3.leaf_number = num_leaves;
	tree3.parent = (int *)malloc(sizeof(int) * (2*num_leaves));
	tree3.lchild = (int *)malloc(sizeof(int) * (2*num_leaves));
	tree3.rchild = (int *)malloc(sizeof(int) * (2*num_leaves));
	tree3.branchlength = (double *)malloc(sizeof(double) * (2*num_leaves));
	tree3.support = (double *)malloc(sizeof(double) * (2*num_leaves));
	tree3.edge = (int **)malloc(sizeof(int *) * (2*num_leaves));
	for(i=0; i<2*num_leaves; i++){
		tree3.edge[i] = (int *)malloc(sizeof(int) * (num_leaves));
	}

	tree2.leaf_number = num_leaves;
	tree2.parent = (int *)malloc(sizeof(int) * (2*num_leaves));
	tree2.lchild = (int *)malloc(sizeof(int) * (2*num_leaves));
	tree2.rchild = (int *)malloc(sizeof(int) * (2*num_leaves));
	tree2.branchlength = (double *)malloc(sizeof(double) * (2*num_leaves));
	tree2.support = (double *)malloc(sizeof(double) * (2*num_leaves));
	tree2.edge = (int **)malloc(sizeof(int *) * (2*num_leaves));
	for(i=0; i<2*num_leaves; i++){
		tree2.edge[i] = (int *)malloc(sizeof(int) * (num_leaves));
	}

	/*tree2.leaf_number = num_leaves;
	tree2.parent = (int *)malloc(sizeof(int) * (2*num_leaves));
	tree2.lchild = (int *)malloc(sizeof(int) * (2*num_leaves));
	tree2.rchild = (int *)malloc(sizeof(int) * (2*num_leaves));
	tree2.branchlength = (double *)malloc(sizeof(double) * (2*num_leaves));
	tree2.support = (double *)malloc(sizeof(double) * (2*num_leaves));
	tree2.edge = (int **)malloc(sizeof(int *) * (2*num_leaves));
	for(i=0; i<2*num_leaves; i++){
		tree2.edge[i] = (int *)malloc(sizeof(int) * (num_leaves));
	}*/
        for(i = 0; i<tree1.leaf_number * 2; i++){
                //if (i < tree1.leaf_number)
                        tree1.support[i] = 1.00;
        }

	for(iii=0; iii<filenumber; iii=iii+1){
		fp = fopen(fastmetreefile, "r");
		if (fp == NULL)
			printf("Error in file opening!\n"); 
		matrixnum = mn = 1 + num_bs;
      	  	while(matrixnum > 0){
			if (matrixnum == mn){
				newick2lcbb(fp, num_leaves, &tree1);
				//printf("%d\n", matrixnum); getchar();
			}else{
				newick2lcbb(fp, num_leaves, &tree3);
				//printf("%d\n", matrixnum); getchar();
			}

			for(i = tree1.leaf_number; i<tree1.leaf_number * 2-3; i++){
				if (matrixnum == mn){
					first_vec(&tree1,i); //printf("OK!\n");getchar();
				}else{ 
					add_vec(&tree3,i);
				}
			}
			matrixnum--;
			//printf("%d",matrixnum); getchar();
		}
		fclose(fp);
		show_fme(mn-1, &tree1);
	}
	//printf("after show!\n");getchar();


        //fdiff = fopen(resultfile, "w");

	Newick_FME(tree1.leaf_number, resultfile1, resultfile2, &tree1, names);


	/*free(tree1.parent);
	free(tree1.lchild);
	free(tree1.rchild);
	free(tree1.branchlength);
	free(tree1.support);
	for(i=0; i<2*num_leaves; i++){
		free(tree1.edge[i]);
	}
	free(tree1.edge);

	free(tree2.parent);
	free(tree2.lchild);
	free(tree2.rchild);
	free(tree2.branchlength);
	for(i=0; i<2*num_leaves; i++){
		free(tree2.edge[i]);
	}
	free(tree2.edge);

	free(tree3.parent);
	free(tree3.lchild);
	free(tree3.rchild);
	free(tree3.branchlength);
	for(i=0; i<2*num_leaves; i++){
		free(tree3.edge[i]);
	}
	free(tree3.edge);*/

}


void write_nj_tree(char *matrixfile, char* resultfile1, char* resultfile2, int num_bs, int num_leaves, int num_genes, char ** names){
        FILE *fp;
        FILE *fq;
        FILE *fdiff;
        int temp;
        int i,j,iii;               //index i and j
        int root;
        int parent, child;
        double dtemp;
        int testsnum;
        int branchmax, dismax;
        double berror;
        int filenumber = 1;
        char filename[100];
        char somenumber[100];
        int matrixnum, mn;
        struct Ptree tree1, tree2;
        tree1.leaf_number = num_leaves;
        tree1.parent = (int *)malloc(sizeof(int) * (2*num_leaves));
        tree1.lchild = (int *)malloc(sizeof(int) * (2*num_leaves));
        tree1.rchild = (int *)malloc(sizeof(int) * (2*num_leaves));
        tree1.branchlength = (double *)malloc(sizeof(double) * (2*num_leaves));
        tree1.support = (double *)malloc(sizeof(double) * (2*num_leaves));
        tree1.edge = (int **)malloc(sizeof(int *) * (2*num_leaves));
        for(i=0; i<2*num_leaves; i++){
                tree1.edge[i] = (int *)malloc(sizeof(int) * (num_leaves));
        }
        tree2.parent = (int *)malloc(sizeof(int) * (2*num_leaves));
        tree2.lchild = (int *)malloc(sizeof(int) * (2*num_leaves));
        tree2.rchild = (int *)malloc(sizeof(int) * (2*num_leaves));
        tree2.branchlength = (double *)malloc(sizeof(double) * (2*num_leaves));
        //tree2.support = (double *)malloc(sizeof(double) * (2*num_leaves));
        tree2.edge = (int **)malloc(sizeof(int *) * (2*num_leaves));
        for(i=0; i<2*num_leaves; i++){
                tree2.edge[i] = (int *)malloc(sizeof(int) * (num_leaves));
        }

        double **DIS = (double **)malloc(sizeof(double *) * (num_leaves));
        for(i=0; i<num_leaves; i++){
                DIS[i] = (double *)malloc(sizeof(double) * (num_leaves));
        }
        for(i = 0; i<tree1.leaf_number * 2; i++){
                //if (i < tree1.leaf_number)
                        tree1.support[i] = 1.00;
        }


        for(iii=0; iii<filenumber; iii=iii+1){
                fp = fopen(matrixfile, "r");

                if (fp == NULL)
                        printf("Error in file opening!\n");
                matrixnum = mn = 1 + num_bs;
                while(matrixnum > 0){
                        fscanf(fp, "%d ", &temp);
                        //if (temp != root-1)
                                //printf("leaf number error!\n");
                        for(i=0; i<temp; i++){
                                for(j=i+1; j<temp; j++){
                                        fscanf(fp, "%d %d %lf", &parent, &child, &dtemp);
                                        DIS[i][j] = dtemp;
                                        if ( (parent != i+1) && (child != j+1) ){
                                                printf("ERROR in indexing! (%d,%d) vs (%d,%d)", parent, child, i+1,j+1);
                                                getchar();
 }
                                        DIS[j][i] = DIS[i][j];
                                }
                                DIS[i][i] = 0;
                        }

                        if (matrixnum == mn){
                                NJtree(temp, &tree1, DIS, num_bs, num_leaves, num_genes);
				//printf("%d\n", matrixnum);
				//getchar();
                        }else{
                                NJtree(temp, &tree2, DIS, num_bs, num_leaves, num_genes);
				//printf("%d\n", matrixnum);
				//getchar();
                        }

                        for(i = tree1.leaf_number; i<tree1.leaf_number * 2-3; i++){
                                if (matrixnum == mn){
                                        first_vec(&tree1,i); //printf("OK!\n");getchar();
                                }else{
                                        add_vec(&tree2,i);
                                }
                        }
                        matrixnum--;
                }
                fclose(fp);
                show_nj(mn-1, &tree1);
        }
        //printf("after show!\n");getchar();


        //fdiff = fopen(resultfile, "w");

        //fclose(fdiff);
        Newick_NJ(tree1.leaf_number, resultfile1, resultfile2, &tree1,names);
	//printf("anything\n");
	//getchar();


        for(i = 0; i < num_leaves; i++)
                free(DIS[i]);
        free(DIS);
        free(tree1.parent);
        free(tree1.lchild);
        free(tree1.rchild);
        free(tree1.branchlength);
        free(tree1.support);
        for(i=0; i<2*num_leaves; i++){
                free(tree1.edge[i]);
        }
        free(tree1.edge);
        free(tree2.parent);
        free(tree2.lchild);
        free(tree2.rchild);
        //free(tree2.support);
        free(tree2.branchlength);
        for(i=0; i<2*num_leaves; i++){
                free(tree2.edge[i]);
        }
        free(tree2.edge);
}

void write_nj_tree_from_matrix(double ***matrixlist, char* resultfile1, char* resultfile2, int num_bs, int num_leaves, int num_genes, char ** names){
        FILE *fq;
        FILE *fdiff;
        int temp;
        int i,j,k,iii;               //index i and j
        int root;
        int parent, child;
        double dtemp;
        int testsnum;
        int branchmax, dismax;
        double berror;
        int filenumber = 1;
        char filename[100];
        char somenumber[100];
        int matrixnum, mn;
        struct Ptree tree1, tree2;
        tree1.parent = (int *)malloc(sizeof(int) * (2*num_leaves));
        tree1.lchild = (int *)malloc(sizeof(int) * (2*num_leaves));
        tree1.rchild = (int *)malloc(sizeof(int) * (2*num_leaves));
        tree1.branchlength = (double *)malloc(sizeof(double) * (2*num_leaves));
        tree1.support = (double *)malloc(sizeof(double) * (2*num_leaves));
        tree1.edge = (int **)malloc(sizeof(int *) * (2*num_leaves));
        for(i=0; i<2*num_leaves; i++){
                tree1.edge[i] = (int *)malloc(sizeof(int) * (num_leaves));
        }
        tree2.parent = (int *)malloc(sizeof(int) * (2*num_leaves));
        tree2.lchild = (int *)malloc(sizeof(int) * (2*num_leaves));
        tree2.rchild = (int *)malloc(sizeof(int) * (2*num_leaves));
        tree2.branchlength = (double *)malloc(sizeof(double) * (2*num_leaves));
        //tree2.support = (double *)malloc(sizeof(double) * (2*num_leaves));
        tree2.edge = (int **)malloc(sizeof(int *) * (2*num_leaves));
        for(i=0; i<2*num_leaves; i++){
                tree2.edge[i] = (int *)malloc(sizeof(int) * (num_leaves));
        }

        double **DIS = (double **)malloc(sizeof(double *) * (num_leaves));
        for(i=0; i<num_leaves; i++){
                DIS[i] = (double *)malloc(sizeof(double) * (num_leaves));
        }
        for(i = 0; i<tree1.leaf_number * 2; i++){
                //if (i < tree1.leaf_number)
                        tree1.support[i] = 1.00;
        }


        for(iii=0; iii<filenumber; iii=iii+1){
                //fp = fopen(matrixfile, "r");
                //if (fp == NULL)
                //      printf("Error in file opening!\n"); 

                matrixnum = mn = 1 + num_bs;
                k = 0;
                while(matrixnum > 0){
                        //fscanf(fp, "%d ", &temp);
                        temp = num_leaves;
                        //if (temp != root-1)
                                //printf("leaf number error!\n");
                        for(i=0; i<temp; i++){
                                for(j=i+1; j<temp; j++){
                                        //fscanf(fp, "%d %d %lf", &parent, &child, &dtemp);
                                        DIS[i][j] = matrixlist[k][i][j];//dtemp;

                                        //if ( (parent != i+1) && (child != j+1) ){
                                        //      printf("ERROR in indexing! (%d,%d) vs (%d,%d)", parent, child, i+1,j+1);
                                        //      getchar();
                                        //}
                                        DIS[j][i] = DIS[i][j];
                                }
                                DIS[i][i] = 0;

                        }
                        //printf("%d %d %lf", parent, child, dtemp);
                        if (matrixnum == mn){
                                NJtree(temp, &tree1, DIS, num_bs, num_leaves, num_genes);
                        }else{
                                NJtree(temp, &tree2, DIS, num_bs, num_leaves, num_genes);
                        }
                        /*if (matrixnum == mn){
                                //printf("TREE: %d\n", matrixnum);
                                for(i = 0; i<tree1.leaf_number * 2-2; i++){
                                        fprintf(fdiff, "%d %d\n", tree1.parent[i]+1,i+1);
                                }
                                //getchar();
                        }*/
                        for(i = tree1.leaf_number; i<tree1.leaf_number * 2-3; i++){
                                if (matrixnum == mn){
                                        first_vec(&tree1,i); //printf("OK!\n");getchar();
                                }else{
                                        add_vec(&tree2,i);
                                }
                        }
                        matrixnum--;k++;
                }
                //fclose(fp);
                show_nj(mn-1, &tree1);
        }
        //fdiff = fopen(resultfile, "w");

        //fclose(fdiff);
        Newick_NJ(tree1.leaf_number, resultfile1, resultfile2, &tree1, names);

        for(i = 0; i < num_leaves; i++)
                free(DIS[i]);
        free(DIS);
        free(tree1.parent);
        free(tree1.lchild);
        free(tree1.rchild);
        free(tree1.branchlength);
        free(tree1.support);
        for(i=0; i<2*num_leaves; i++){
                free(tree1.edge[i]);
        }
        free(tree1.edge);

        free(tree2.parent);
	free(tree2.lchild);
        free(tree2.rchild);
        //free(tree2.support);
        free(tree2.branchlength);
        for(i=0; i<2*num_leaves; i++){
                free(tree2.edge[i]);
        }
        free(tree2.edge);

}




/*
int main(int argc, char *argv[])
{
	int num_bt;
	int num_leaf;
	int num_gene;
	if (argc != 7 ){
		printf("usage: process_fastme_matrix <input filename> <output tree> <output bootstraping support tree> <# bootstraps> <# of leaves> <# of genes>\n");	
		exit(1);
	}
	num_bt = atoi(argv[4]);
	num_leaf = atoi(argv[5]);
	num_gene = atoi(argv[6]);
  	write_tree(argv[1], argv[2], argv[3], num_bt, num_leaf, num_gene);
}
*/
